require 'rest-client'
require 'date'
require 'json'

class GithubActivity
  attr_reader :response, :date, :json

  def initialize(username, date = Date.today)
    @username = username
    @date = date
    @json = RestClient.get("https://github-contributions-api.herokuapp.com/#{@username}/count")
    @response = JSON.parse(@json)
  end

  def today
    response['data'][date.year.to_s][date.month.to_s][date.day.to_s]
  end

  def last_week
    get_activity(6)
  end

  def last_month
  end


  private
  def get_activity(num_days)
    ((date - num_days)..date).to_a.sum do |prev_date|
      get_score(prev_date)
    end
  end

  def get_score(prev_date)
    num = response['data'][prev_date.year.to_s][prev_date.month.to_s][prev_date.day.to_s]
    num.nil? ? 0 : num
  end
end
